



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>mybatis学习笔记（五） -- maven+spring+mybatis从零开始搭建整合详细过程（附demo和搭建过程遇到的问题解决方法）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">mybatis学习笔记（五） -- maven+spring+mybatis从零开始搭建整合详细过程（附demo和搭建过程遇到的问题解决方法）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 07:28:52 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>文章介绍结构一览</strong></p>
<p><strong>一、使用maven创建web项目</strong></p>
<p>1、新建maven项目</p>
<p>2、修改jre版本</p>
<p>3、修改Project Facts，生成WebContent文件夾</p>
<p>4、将WebContent下的两个文件复制到src/main/webapp下，删掉WebContent</p>
<p>5、修改Deployment Assembly</p>
<p>6、测试</p>
<p><strong>二、mybatis访问mysql</strong></p>
<p>1、数据库准备</p>
<p>2、修改pom.xml</p>
<p>3、创建实体类</p>
<p>4、创建访问接口</p>
<p>5、添加映射文件</p>
<p>6、添加MyBatisCfg.xml配置文件，注册mapper，实体类别名</p>
<p>7、添加MyBatisUtil工具类</p>
<p>8、创建Impl类继承接口</p>
<p>9、测试</p>
<p>10、添加log4j2配置（控制台看到向数据库发送的SQL请求，及数据库向程序响应）</p>
<p><strong>三、Spring与Mybatis初级整合</strong></p>
<p>1、修改pom.xml</p>
<p>2、添加ApplicationContext.xml，修改MyBatisCfg.xml</p>
<p>3、测试</p>
<p><strong>四、Spring与Mybatis整合升级&nbsp;</strong></p>
<p>1、修改ApplicationContext.xml，引入自动扫描，弃用MyBasticCfg.xml</p>
<p>2、修改测试类，测试</p>
<p>Demo下载：<a href="http://files.cnblogs.com/files/lmei/spring_mybatis_1.rar" rel="external nofollow noreferrer">spring_mybatis_1.rar</a></p>
<p>项目结构如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170707153237612-607443869.jpg" /></p>
<p><strong>正式开始！！！</strong></p>
<h3><strong>一、使用maven创建web项目</strong></h3>
<p>1、新建项目</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706142549237-17992321.jpg" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706142604456-1945726261.jpg" /></p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706142613925-2027763790.jpg" /></p>
<p>填写完成后，创建成功。</p>
<p>2、修改jre版本</p>
<p>properties-&gt;java build path，把默认的1.5版本remove，</p>
<p>然后Add Library-&gt; JRE Library System-&gt;选择&nbsp;Workspace default JRE</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706143149659-1548035477.jpg" /></p>
<p>选择完成后，可以在Library列表看到这个</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706143452940-930615812.jpg" /></p>
<p>3、修改Project Facts</p>
<p>properties-&gt;Project Facts，修改java版本，然后把Dynamic Web Module前面打上勾</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706143850175-1466624286.jpg" /></p>
<p>Apply后，查看项目结构可以看到多了个WebContent</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706145117487-1442772231.jpg" /></p>
<p>4、将WebContent下的两个文件复制到src/main/webapp下，然后将WebContent整个删掉</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706145137112-224049749.jpg" /></p>
<p>5、修改Deployment Assembly，只留下下面几个</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706145630284-1028347052.jpg" /></p>
<p>新增/src/main/webapp，步骤Add-&gt;Floder-&gt;src-&gt;main-&gt;webapp-&gt;finish</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706145951269-1708883607.jpg" /></p>
<p>6、测试，在src/main/webapp下，新建一个index.jsp文件</p>
<div>
<pre class="prettyprint linenums">&lt;%@ page language="java" contentType="text/html; charset=UTF-8"<br />
    pageEncoding="UTF-8"%&gt;<br />
&lt;!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"&gt;<br />
&lt;html&gt;<br />
&lt;head&gt;<br />
&lt;meta http-equiv="Content-Type" content="text/html; charset=UTF-8"&gt;<br />
&lt;title&gt;Insert title here&lt;/title&gt;<br />
&lt;/head&gt;<br />
&lt;body&gt;hello<br />
&lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div>
<p>运行tomcat，访问：http://localhost:8888/spring_mybatis_1/，页面显示&ldquo;hello&rdquo;</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706150649097-671685402.jpg" /></p>
<h3><strong>二、mybatis访问mysql</strong></h3>
<p>1、数据库准备，新建数据表tb_book，添加测试数据</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706151426597-1075818903.jpg" /></p>
<p>2、修改pom.xml文件，新增下面代码</p>
<div>
<pre class="prettyprint linenums">&lt;dependencies&gt;<br />
    &lt;dependency&gt;<br />
        &lt;groupId&gt;mysql&lt;/groupId&gt;<br />
        &lt;artifactId&gt;mysql-connector-java&lt;/artifactId&gt;<br />
        &lt;version&gt;5.1.38&lt;/version&gt;<br />
    &lt;/dependency&gt;<br />
    &lt;dependency&gt;<br />
        &lt;groupId&gt;org.apache.logging.log4j&lt;/groupId&gt;<br />
        &lt;artifactId&gt;log4j-core&lt;/artifactId&gt;<br />
        &lt;version&gt;2.6.1&lt;/version&gt;<br />
    &lt;/dependency&gt;<br />
    &lt;dependency&gt;<br />
        &lt;groupId&gt;org.mybatis&lt;/groupId&gt;<br />
        &lt;artifactId&gt;mybatis&lt;/artifactId&gt;<br />
        &lt;version&gt;3.4.1&lt;/version&gt;<br />
    &lt;/dependency&gt;<br />
    &lt;dependency&gt;<br />
        &lt;groupId&gt;junit&lt;/groupId&gt;<br />
        &lt;artifactId&gt;junit&lt;/artifactId&gt;<br />
        &lt;version&gt;4.10&lt;/version&gt;<br />
    &lt;/dependency&gt;<br />
&lt;/dependencies&gt;</pre>
</div>
<p>完整pom.xml文件，</p>
<div>
<div>
<pre class="prettyprint linenums">&lt;project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"<br />
    xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd"&gt;<br />
    &lt;modelVersion&gt;4.0.0&lt;/modelVersion&gt;<br />
    &lt;groupId&gt;com.lmei&lt;/groupId&gt;<br />
    &lt;artifactId&gt;spring_mybatis_1&lt;/artifactId&gt;<br />
    &lt;version&gt;0.0.1-SNAPSHOT&lt;/version&gt;<br />
    &lt;packaging&gt;war&lt;/packaging&gt;

    &lt;dependencies&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;mysql&lt;/groupId&gt;<br />
            &lt;artifactId&gt;mysql-connector-java&lt;/artifactId&gt;<br />
            &lt;version&gt;5.1.38&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.apache.logging.log4j&lt;/groupId&gt;<br />
            &lt;artifactId&gt;log4j-core&lt;/artifactId&gt;<br />
            &lt;version&gt;2.6.1&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.mybatis&lt;/groupId&gt;<br />
            &lt;artifactId&gt;mybatis&lt;/artifactId&gt;<br />
            &lt;version&gt;3.4.1&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;junit&lt;/groupId&gt;<br />
            &lt;artifactId&gt;junit&lt;/artifactId&gt;<br />
            &lt;version&gt;4.10&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
    &lt;/dependencies&gt;

&lt;/project&gt;</pre>
</div>
<p>pom.xml</p></div>
<p>3、创建实体类，Book(id,bookName)</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706152401394-1993409721.jpg" /></p>
<div>
<pre class="prettyprint linenums">package com.lmei.entity;

public class Book {

    private int id;<br />
    private String bookName;

    public int getId() {<br />
        return id;<br />
    }

    public void setId(int id) {<br />
        this.id = id;<br />
    }

    public String getBookName() {<br />
        return bookName;<br />
    }

    public void setBookName(String bookName) {<br />
        this.bookName = bookName;<br />
    }

}</pre>
</div>
<p>4、创建访问接口</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706152926394-755980143.jpg" /></p>
<div>
<pre class="prettyprint linenums">package com.lmei.dao;

import java.util.List;<br />
import com.lmei.entity.*;

public interface BookDaoI {<br />
    public List&lt;Book&gt; getAllBook();<br />
}</pre>
</div>
<p>5、添加映射文件</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706153139456-1815129045.jpg" /></p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8" ?&gt;<br />
&lt;!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd"&gt;<br />
&lt;mapper namespace="com.lmei.dao.BookDaoI"&gt;<br />
    &lt;select id="getAllBook" parameterType="int" resultType="Book"&gt;<br />
        select * from tb_book<br />
    &lt;/select&gt;<br />
&lt;/mapper&gt;</pre>
</div>
<p>6、新建MyBatisCfg.xml文件，用于配置MyBatis运行环境</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706153659362-1138656818.jpg" /></p>
<p>新增db.properties</p>
<div>
<pre class="prettyprint linenums">driver=com.mysql.jdbc.Driver<br />
url=jdbc:mysql://localhost:3306/test?useUnicode=true&amp;characterEncoding=UTF-8&amp;zeroDateTimeBehavior=convertToNull<br />
username=root<br />
password=</pre>
</div>
<p>新增MyBatisCfg.xml</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
&lt;!DOCTYPE configuration<br />
  PUBLIC "-//mybatis.org//DTD Config 3.0//EN"<br />
  "http://mybatis.org/dtd/mybatis-3-config.dtd"&gt;<br />
&lt;configuration&gt;<br />
    &lt;!-- 指定数据库连接信息的位置 --&gt;<br />
    &lt;properties resource="db.properties"&gt;&lt;/properties&gt;

    &lt;environments default="development"&gt;<br />
        &lt;environment id="development"&gt;<br />
            &lt;transactionManager type="JDBC" /&gt;<br />
            &lt;dataSource type="POOLED"&gt;<br />
                &lt;property name="driver" value="${driver}" /&gt;<br />
                &lt;property name="url" value="${url}" /&gt;<br />
                &lt;property name="username" value="${username}" /&gt;<br />
                &lt;property name="password" value="${password}" /&gt;<br />
            &lt;/dataSource&gt;<br />
        &lt;/environment&gt;<br />
    &lt;/environments&gt;

&lt;/configuration&gt;</pre>
</div>
<p>在MyBatisCfg.xml加入&ldquo;com.lmei.entity"别名配置，注册mapper</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
&lt;!DOCTYPE configuration<br />
  PUBLIC "-//mybatis.org//DTD Config 3.0//EN"<br />
  "http://mybatis.org/dtd/mybatis-3-config.dtd"&gt;<br />
&lt;configuration&gt;<br />
    &lt;!-- 指定数据库连接信息的位置 --&gt;<br />
    &lt;properties resource="db.properties"&gt;&lt;/properties&gt;

    &lt;!--com.lmei.entity下的所有类定义别名 --&gt;<br />
    &lt;typeAliases&gt;<br />
        &lt;package name="com.lmei.entity"/&gt;<br />
    &lt;/typeAliases&gt;

    &lt;environments default="development"&gt;<br />
        &lt;environment id="development"&gt;<br />
            &lt;transactionManager type="JDBC" /&gt;<br />
            &lt;dataSource type="POOLED"&gt;<br />
                &lt;property name="driver" value="${driver}" /&gt;<br />
                &lt;property name="url" value="${url}" /&gt;<br />
                &lt;property name="username" value="${username}" /&gt;<br />
                &lt;property name="password" value="${password}" /&gt;<br />
            &lt;/dataSource&gt;<br />
        &lt;/environment&gt;<br />
    &lt;/environments&gt;<br />
    &lt;mappers&gt;<br />
        &lt;!--注册BookMapper映射--&gt;<br />
        &lt;mapper resource="com/lmei/mapper/BookMapper.xml" /&gt;<br />
    &lt;/mappers&gt;<br />
&lt;/configuration&gt;</pre>
</div>
<p>注：关于实体类别名可参考：<a href="http://www.cnblogs.com/lmei/p/7102669.html" rel="external nofollow noreferrer">mybatis学习笔记(四）-- 为实体类定义别名两种方法（基于xml映射）</a></p>
<p>7、新增MyBatisUtil工具类</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706155704347-1925013763.jpg" /></p>
<div>
<pre class="prettyprint linenums">package com.lmei.util;

import java.io.InputStream;<br />
import org.apache.ibatis.session.SqlSession;<br />
import org.apache.ibatis.session.SqlSessionFactory;<br />
import org.apache.ibatis.session.SqlSessionFactoryBuilder;

public class MyBatisUtil {

    /**<br />
     * 获取SqlSessionFactory<br />
     * @return SqlSessionFactory<br />
     */<br />
    public static SqlSessionFactory getSqlSessionFactory() {<br />
        String resource = "MyBatisCfg.xml";<br />
        InputStream is = MyBatisUtil.class.getClassLoader().getResourceAsStream(resource);<br />
        SqlSessionFactory factory = new SqlSessionFactoryBuilder().build(is);<br />
        return factory;<br />
    }

    /**<br />
     * 获取SqlSession<br />
     * @return SqlSession<br />
     */<br />
    public static SqlSession getSqlSession() {<br />
        return getSqlSessionFactory().openSession();<br />
    }

    /**<br />
     * 获取SqlSession<br />
     * @param isAutoCommit<br />
     *         true 表示创建的SqlSession对象在执行完SQL之后会自动提交事务<br />
     *         false 表示创建的SqlSession对象在执行完SQL之后不会自动提交事务，这时就需要我们手动调用sqlSession.commit()提交事务<br />
     * @return SqlSession<br />
     */<br />
    public static SqlSession getSqlSession(boolean isAutoCommit) {<br />
        return getSqlSessionFactory().openSession(isAutoCommit);<br />
    }<br />
}</pre>
</div>
<p>8、创建Impl类实现接口</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706155954315-1775303892.jpg" /></p>
<p>新建BookImpl类，继承BookDaoI接口</p>
<div>
<pre class="prettyprint linenums">package com.lmei.dao.impl;

import java.util.List;<br />
import org.apache.ibatis.session.SqlSession;

import com.lmei.entity.*;<br />
import com.lmei.util.MyBatisUtil;<br />
import com.lmei.dao.*;;

public class BookImpl implements BookDaoI {

    @Override<br />
    public List&lt;Book&gt; getAllBook() {<br />
        //获得会话对象<br />
        SqlSession session= MyBatisUtil.getSqlSession(true);<br />
        try {<br />
            BookDaoI bookDao = session.getMapper(BookDaoI.class);<br />
            return bookDao.getAllBook();<br />
        } finally {<br />
            session.close();<br />
        }<br />
    }<br />
}</pre>
</div>
<p>9、测试</p>
<p>添加测试类TestBookImpl.java</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706160549487-79524582.jpg" /></p>
<div>
<pre class="prettyprint linenums">package com.lmei.test;

import static org.junit.Assert.*;<br />
import java.util.List;<br />
import org.junit.BeforeClass;<br />
import org.junit.Test;

import com.lmei.dao.impl.*;<br />
import com.lmei.entity.*;<br />
import com.lmei.dao.*;

public class TestBookImpl {

    static BookDaoI bookDao;<br />
    @BeforeClass<br />
    public static void beforeClass()<br />
    {<br />
        bookDao = new BookImpl();<br />
    }

    @Test<br />
    public void testGetAllBookTypes() {<br />
        List&lt;Book&gt; books = bookDao.getAllBook();<br />
        for (Book book : books) {<br />
            System.out.println(book.getBookName());<br />
        }<br />
        assertNotNull(books);<br />
    }<br />
}</pre>
</div>
<p>项目右键-&gt;Run As-&gt;JUnit Test，控制台输出</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706160854706-474505046.jpg" /></p>
<p>输出成，但&nbsp;出现错误：&ldquo;ERROR StatusLogger No log4j2 configuration file found. Using default configuration: logging only errors to the console.&rdquo;</p>
<p>新增log4j2.xml配置文件，文件位置如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706161950269-1532225320.jpg" /></p>
<div>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
&lt;Configuration status="off" monitorInterval="1800"&gt;<br />
    &lt;Appenders&gt;<br />
        &lt;Console name="Console" target="SYSTEM_OUT"&gt;<br />
            &lt;PatternLayout pattern="%d{HH:mm:ss.SSS} [%t] %-5level %logger{36} - %msg%n" /&gt;<br />
        &lt;/Console&gt;<br />
    &lt;/Appenders&gt;

    &lt;Loggers&gt;<br />
        &lt;Root level="debug"&gt;<br />
            &lt;AppenderRef ref="Console" /&gt;<br />
        &lt;/Root&gt;<br />
    &lt;/Loggers&gt;<br />
&lt;/Configuration&gt;</pre>
</div>
<p>log4j2.xml</p></div>
<p>添加完成后，重新运行，可以在控制台看到向数据库发送的SQL请求，及数据库向程序响应的结果</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706162330581-1260648726.jpg" /></p>
<p>但还有一个警告！</p>
<p>&ldquo;Description Resource Path Location Type</p>
<p>No grammar constraints (DTD or XML schema) detected for the document. log4j2.xml /spring_mybatis_1/src/main/resources line 1 XML Problem<em>&rdquo;</em></p>
<p>修改log4j2.xml如下，即可</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8" standalone="no"?&gt;<br />
&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/2002/xmlspec/dtd/2.10/xmlspec.dtd"&gt;<br />
&lt;Configuration status="off" monitorInterval="1800"&gt;<br />
    &lt;Appenders&gt;<br />
        &lt;Console name="Console" target="SYSTEM_OUT"&gt;<br />
            &lt;PatternLayout pattern="%d{HH:mm:ss.SSS} [%t] %-5level %logger{36} - %msg%n" /&gt;<br />
        &lt;/Console&gt;<br />
    &lt;/Appenders&gt;

    &lt;Loggers&gt;<br />
        &lt;Root level="debug"&gt;<br />
            &lt;AppenderRef ref="Console" /&gt;<br />
        &lt;/Root&gt;<br />
    &lt;/Loggers&gt;<br />
&lt;/Configuration&gt;</pre>
</div>
<h3><strong>三、Spring与MyBatis初级整合</strong></h3>
<p>1、修改pom.xml文件，新增下面这些包</p>
<div>
<pre class="prettyprint linenums">&lt;!-- 添加Spring-core包 --&gt;<br />
&lt;dependency&gt;<br />
    &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
    &lt;artifactId&gt;spring-core&lt;/artifactId&gt;<br />
    &lt;version&gt;4.1.4.RELEASE&lt;/version&gt;<br />
&lt;/dependency&gt;<br />
&lt;!-- 添加spring-context包 --&gt;<br />
&lt;dependency&gt;<br />
    &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
    &lt;artifactId&gt;spring-context&lt;/artifactId&gt;<br />
    &lt;version&gt;4.1.4.RELEASE&lt;/version&gt;<br />
&lt;/dependency&gt;<br />
&lt;!-- 添加spring-tx包 --&gt;<br />
&lt;dependency&gt;<br />
    &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
    &lt;artifactId&gt;spring-tx&lt;/artifactId&gt;<br />
    &lt;version&gt;4.1.4.RELEASE&lt;/version&gt;<br />
&lt;/dependency&gt;<br />
&lt;!-- 添加spring-jdbc包 --&gt;<br />
&lt;dependency&gt;<br />
    &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
    &lt;artifactId&gt;spring-jdbc&lt;/artifactId&gt;<br />
    &lt;version&gt;4.1.4.RELEASE&lt;/version&gt;<br />
&lt;/dependency&gt;<br />
&lt;!-- 为了方便进行单元测试，添加spring-test包 --&gt;<br />
&lt;dependency&gt;<br />
    &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
    &lt;artifactId&gt;spring-test&lt;/artifactId&gt;<br />
    &lt;version&gt;4.1.4.RELEASE&lt;/version&gt;<br />
&lt;/dependency&gt;<br />
&lt;!--添加spring-web包 --&gt;<br />
&lt;dependency&gt;<br />
    &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
    &lt;artifactId&gt;spring-web&lt;/artifactId&gt;<br />
    &lt;version&gt;4.1.4.RELEASE&lt;/version&gt;<br />
&lt;/dependency&gt;<br />
&lt;!--添加aspectjweaver包 --&gt;<br />
&lt;dependency&gt;<br />
    &lt;groupId&gt;org.aspectj&lt;/groupId&gt;<br />
    &lt;artifactId&gt;aspectjweaver&lt;/artifactId&gt;<br />
    &lt;version&gt;1.8.5&lt;/version&gt;<br />
&lt;/dependency&gt;<br />
&lt;!-- 添加mybatis与Spring整合的核心包 --&gt;<br />
&lt;dependency&gt;<br />
    &lt;groupId&gt;org.mybatis&lt;/groupId&gt;<br />
    &lt;artifactId&gt;mybatis-spring&lt;/artifactId&gt;<br />
    &lt;version&gt;<strong>1.3.0</strong>&lt;/version&gt;<br />
&lt;/dependency&gt;</pre>
</div>
<p>完整pom.xml</p>
<div>
<div>
<pre class="prettyprint linenums">&lt;project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"<br />
    xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd"&gt;<br />
    &lt;modelVersion&gt;4.0.0&lt;/modelVersion&gt;<br />
    &lt;groupId&gt;com.lmei&lt;/groupId&gt;<br />
    &lt;artifactId&gt;spring_mybatis_1&lt;/artifactId&gt;<br />
    &lt;version&gt;0.0.1-SNAPSHOT&lt;/version&gt;<br />
    &lt;packaging&gt;war&lt;/packaging&gt;

    &lt;dependencies&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;mysql&lt;/groupId&gt;<br />
            &lt;artifactId&gt;mysql-connector-java&lt;/artifactId&gt;<br />
            &lt;version&gt;5.1.38&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.apache.logging.log4j&lt;/groupId&gt;<br />
            &lt;artifactId&gt;log4j-core&lt;/artifactId&gt;<br />
            &lt;version&gt;2.6.1&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.mybatis&lt;/groupId&gt;<br />
            &lt;artifactId&gt;mybatis&lt;/artifactId&gt;<br />
            &lt;version&gt;3.4.1&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;junit&lt;/groupId&gt;<br />
            &lt;artifactId&gt;junit&lt;/artifactId&gt;<br />
            &lt;version&gt;4.10&lt;/version&gt;<br />
        &lt;/dependency&gt;

        &lt;!-- 添加Spring-core包 --&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
            &lt;artifactId&gt;spring-core&lt;/artifactId&gt;<br />
            &lt;version&gt;4.1.4.RELEASE&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;!-- 添加spring-context包 --&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
            &lt;artifactId&gt;spring-context&lt;/artifactId&gt;<br />
            &lt;version&gt;4.1.4.RELEASE&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;!-- 添加spring-tx包 --&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
            &lt;artifactId&gt;spring-tx&lt;/artifactId&gt;<br />
            &lt;version&gt;4.1.4.RELEASE&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;!-- 添加spring-jdbc包 --&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
            &lt;artifactId&gt;spring-jdbc&lt;/artifactId&gt;<br />
            &lt;version&gt;4.1.4.RELEASE&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;!-- 为了方便进行单元测试，添加spring-test包 --&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
            &lt;artifactId&gt;spring-test&lt;/artifactId&gt;<br />
            &lt;version&gt;4.1.4.RELEASE&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;!--添加spring-web包 --&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.springframework&lt;/groupId&gt;<br />
            &lt;artifactId&gt;spring-web&lt;/artifactId&gt;<br />
            &lt;version&gt;4.1.4.RELEASE&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;!--添加aspectjweaver包 --&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.aspectj&lt;/groupId&gt;<br />
            &lt;artifactId&gt;aspectjweaver&lt;/artifactId&gt;<br />
            &lt;version&gt;1.8.5&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;!-- 添加mybatis与Spring整合的核心包 --&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.mybatis&lt;/groupId&gt;<br />
            &lt;artifactId&gt;mybatis-spring&lt;/artifactId&gt;<br />
            &lt;version&gt;1.3.0&lt;/version&gt;<br />
        &lt;/dependency&gt;

    &lt;/dependencies&gt;

&lt;/project&gt;</pre>
</div>
<p>pom.xml</p></div>
<p>初次配置时，运行测试，报错&ldquo;java.lang.AbstractMethodError: org.mybatis.spring.transaction.SpringManagedTransaction.getTimeout()Ljava/lang/Integer;&rdquo;</p>
<p>完整的错误信息：</p>
<div>
<div>
<pre class="prettyprint linenums">java.lang.AbstractMethodError: org.mybatis.spring.transaction.SpringManagedTransaction.getTimeout()Ljava/lang/Integer;<br />
    at org.apache.ibatis.executor.SimpleExecutor.prepareStatement(SimpleExecutor.java:)<br />
    at org.apache.ibatis.executor.SimpleExecutor.doQuery(SimpleExecutor.java:)<br />
    at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:)<br />
    at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:)<br />
    at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:)<br />
    at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:)<br />
    at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:)<br />
    at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:)<br />
    at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)<br />
    at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:)<br />
    at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:)<br />
    at java.lang.reflect.Method.invoke(Method.java:)<br />
    at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:)<br />
    at com.sun.proxy.$Proxy7.selectList(Unknown Source)<br />
    at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:)<br />
    at org.apache.ibatis.binding.MapperMethod.executeForMany(MapperMethod.java:)<br />
    at org.apache.ibatis.binding.MapperMethod.execute(MapperMethod.java:)<br />
    at org.apache.ibatis.binding.MapperProxy.invoke(MapperProxy.java:)<br />
    at com.sun.proxy.$Proxy8.getAllBook(Unknown Source)<br />
    at com.lmei.test.TestMyBatisSpring.test(TestMyBatisSpring.java:)<br />
    at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)<br />
    at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:)<br />
    at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:)<br />
    at java.lang.reflect.Method.invoke(Method.java:)<br />
    at org.junit.runners.model.FrameworkMethod$.runReflectiveCall(FrameworkMethod.java:)<br />
    at org.junit.internal.runners.model.ReflectiveCallable.run(ReflectiveCallable.java:)<br />
    at org.junit.runners.model.FrameworkMethod.invokeExplosively(FrameworkMethod.java:)<br />
    at org.junit.internal.runners.statements.InvokeMethod.evaluate(InvokeMethod.java:)<br />
    at org.junit.runners.ParentRunner.runLeaf(ParentRunner.java:)<br />
    at org.junit.runners.BlockJUnit4ClassRunner.runChild(BlockJUnit4ClassRunner.java:)<br />
    at org.junit.runners.BlockJUnit4ClassRunner.runChild(BlockJUnit4ClassRunner.java:)<br />
    at org.junit.runners.ParentRunner$.run(ParentRunner.java:)<br />
    at org.junit.runners.ParentRunner$.schedule(ParentRunner.java:)<br />
    at org.junit.runners.ParentRunner.runChildren(ParentRunner.java:)<br />
    at org.junit.runners.ParentRunner.access$(ParentRunner.java:)<br />
    at org.junit.runners.ParentRunner$.evaluate(ParentRunner.java:)<br />
    at org.junit.runners.ParentRunner.run(ParentRunner.java:)<br />
    at org.eclipse.jdt.internal.junit4.runner.JUnit4TestReference.run(JUnit4TestReference.java:)<br />
    at org.eclipse.jdt.internal.junit.runner.TestExecution.run(TestExecution.java:)<br />
    at org.eclipse.jdt.internal.junit.runner.RemoteTestRunner.runTests(RemoteTestRunner.java:)<br />
    at org.eclipse.jdt.internal.junit.runner.RemoteTestRunner.runTests(RemoteTestRunner.java:)<br />
    at org.eclipse.jdt.internal.junit.runner.RemoteTestRunner.run(RemoteTestRunner.java:)<br />
    at org.eclipse.jdt.internal.junit.runner.RemoteTestRunner.main(RemoteTestRunner.java:)</pre>
</div>
<p>错误信息</p></div>
<p>一开始的mybatis-spring配置的版本是<strong>1.2.2</strong>，发生版本不兼容的问题，将其改为<strong>1.3.0</strong>就没问题了，上面pom.xml配置信息是<strong>1.3.0</strong></p>
<p>2、添加ApplicationContext.xml配置</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706182206019-1440108630.jpg" /></p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;

&lt;beans xmlns="http://www.springframework.org/schema/beans"<br />
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:p="http://www.springframework.org/schema/p"<br />
    xmlns:aop="http://www.springframework.org/schema/aop" xmlns:context="http://www.springframework.org/schema/context"<br />
    xsi:schemaLocation="http://www.springframework.org/schema/beans<br />
        http://www.springframework.org/schema/beans/spring-beans.xsd<br />
        http://www.springframework.org/schema/context<br />
        http://www.springframework.org/schema/context/spring-context-4.3.xsd<br />
        http://www.springframework.org/schema/aop<br />
        http://www.springframework.org/schema/aop/spring-aop-4.3.xsd"&gt;

    &lt;!-- 引入db.properties属性文件 --&gt;<br />
    &lt;context:property-placeholder location="classpath:db.properties" /&gt;

    &lt;!--定义一个jdbc数据源，创建一个驱动管理数据源的bean --&gt;<br />
    &lt;bean id="jdbcDataSource"<br />
        class="org.springframework.jdbc.datasource.DriverManagerDataSource"&gt;<br />
        &lt;property name="driverClassName" value="${driver}" /&gt;<br />
        &lt;property name="url" value="${url}" /&gt;<br />
        &lt;property name="username" value="${username}" /&gt;<br />
        &lt;property name="password" value="${password}" /&gt;<br />
    &lt;/bean&gt;

    &lt;!--创建一个sql会话工厂bean，指定数据源 --&gt;<br />
    &lt;bean id="sqlSessionFactory" class="org.mybatis.spring.SqlSessionFactoryBean"&gt;<br />
        &lt;property name="dataSource" ref="jdbcDataSource" /&gt;&lt;!-- 指定数据源 --&gt;<br />
        &lt;property name="configLocation" value="classpath:MyBatisCfg.xml"&gt;&lt;/property&gt; &lt;!-- 指定配置文件 --&gt;<br />
    &lt;/bean&gt;

    &lt;!--创建一个bookDao --&gt;<br />
    &lt;bean id="bookDao" class="org.mybatis.spring.mapper.MapperFactoryBean"&gt;<br />
        &lt;!--指定映射文件 --&gt;<br />
        &lt;property name="mapperInterface" value="com.lmei.dao.BookDaoI"&gt;&lt;/property&gt;<br />
        &lt;!-- 指定sql会话工厂 --&gt;<br />
        &lt;property name="sqlSessionFactory" ref="sqlSessionFactory"&gt;&lt;/property&gt;<br />
    &lt;/bean&gt;<br />
&lt;/beans&gt;</pre>
</div>
<p>测试时报错&ldquo;java.sql.SQLException: Access denied for user 'USER'@'localhost' (using password: YES)&rdquo;</p>
<p>出错在这句配置： &lt;property name="username" value="${username}" /&gt;</p>
<p>发生属性冲突，将配置文件里的username换成其他的名字即可, 如jdbc.username</p>
<p><strong>原因</strong>: （参考来自<a href="http://blog.csdn.net/hy245120020/article/details/51821950" rel="external nofollow noreferrer">http://blog.csdn.net/hy245120020/article/details/51821950</a>）</p>
<p>username在windows下默认取值为电脑的账号，一般电脑账号为administrator，</p>
<p>如果你的电脑账号是自己设置的那就为你设置的账号，数据库连接时数据库中没有administrator用户或者跟你电脑账号一样名字的用户，就会报错。</p>
<p>一般为了避免和Windows基本配置冲突，数据库连接名常常写的较长如{jdbc.username}这样就可以唯一识别用户名而不会和Windows冲突。</p>
<p>将db.properties文件中的进行修改，如下（其他并不会冲突，但为了统一都改了）</p>
<div>
<pre class="prettyprint linenums">jdbc.driver=com.mysql.jdbc.Driver<br />
jdbc.url=jdbc:mysql://localhost:3306/test?useUnicode=true&amp;characterEncoding=UTF-8&amp;zeroDateTimeBehavior=convertToNull<br />
jdbc.username=root<br />
jdbc.password=</pre>
</div>
<p>将上面的ApplicationContext.xml进行修改</p>
<div>
<pre class="prettyprint linenums">&lt;bean id="jdbcDataSource"<br />
        class="org.springframework.jdbc.datasource.DriverManagerDataSource"&gt;<br />
    &lt;property name="driverClassName" value="${jdbc.driver}" /&gt;<br />
    &lt;property name="url" value="${jdbc.url}" /&gt;<br />
    &lt;property name="username" value="${jdbc.username}" /&gt;<br />
    &lt;property name="password" value="${jdbc.password}" /&gt;<br /> &lt;/bean&gt;</pre>
</div>
<p>修改后的完整ApplicationContext.xml</p>
<div>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;

&lt;beans xmlns="http://www.springframework.org/schema/beans"<br />
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:p="http://www.springframework.org/schema/p"<br />
    xmlns:aop="http://www.springframework.org/schema/aop" xmlns:context="http://www.springframework.org/schema/context"<br />
    xsi:schemaLocation="http://www.springframework.org/schema/beans<br />
        http://www.springframework.org/schema/beans/spring-beans.xsd<br />
        http://www.springframework.org/schema/context<br />
        http://www.springframework.org/schema/context/spring-context-4.3.xsd<br />
        http://www.springframework.org/schema/aop<br />
        http://www.springframework.org/schema/aop/spring-aop-4.3.xsd"&gt;

    &lt;!-- 引入db.properties属性文件 --&gt;<br />
    &lt;context:property-placeholder location="classpath:db.properties" /&gt;

    &lt;!--定义一个jdbc数据源，创建一个驱动管理数据源的bean --&gt;<br />
    &lt;bean id="jdbcDataSource"<br />
        class="org.springframework.jdbc.datasource.DriverManagerDataSource"&gt;<br />
        &lt;property name="driverClassName" value="${jdbc.driver}" /&gt;<br />
        &lt;property name="url" value="${jdbc.url}" /&gt;<br />
        &lt;property name="username" value="${jdbc.username}" /&gt;<br />
        &lt;property name="password" value="${jdbc.password}" /&gt;<br />
    &lt;/bean&gt;

    &lt;!--创建一个sql会话工厂bean，指定数据源 --&gt;<br />
    &lt;bean id="sqlSessionFactory" class="org.mybatis.spring.SqlSessionFactoryBean"&gt;<br />
        &lt;property name="dataSource" ref="jdbcDataSource" /&gt;&lt;!-- 指定数据源 --&gt;<br />
        &lt;property name="configLocation" value="classpath:MyBatisCfg.xml"&gt;&lt;/property&gt; &lt;!-- 指定配置文件 --&gt;<br />
    &lt;/bean&gt;

    &lt;!--创建一个bookDao --&gt;<br />
    &lt;bean id="bookDao" class="org.mybatis.spring.mapper.MapperFactoryBean"&gt;<br />
        &lt;!--指定映射文件 --&gt;<br />
        &lt;property name="mapperInterface" value="com.lmei.dao.BookDaoI"&gt;&lt;/property&gt;<br />
        &lt;!-- 指定sql会话工厂 --&gt;<br />
        &lt;property name="sqlSessionFactory" ref="sqlSessionFactory"&gt;&lt;/property&gt;<br />
    &lt;/bean&gt;<br />
&lt;/beans&gt;</pre>
</div>
<p>ApplicationContext.xml</p></div>
<p>MyBatisCfg.xml中连接数据库部分可以删除</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
&lt;!DOCTYPE configuration<br />
  PUBLIC "-//mybatis.org//DTD Config 3.0//EN"<br />
  "http://mybatis.org/dtd/mybatis-3-config.dtd"&gt;<br />
&lt;configuration&gt;<br />
    &lt;!-- 指定数据库连接信息的位置 --&gt;<br />
    &lt;properties resource="db.properties"&gt;&lt;/properties&gt;

    &lt;!--com.lmei.entity下的所有类定义别名 --&gt;<br />
    &lt;typeAliases&gt;<br />
        &lt;package name="com.lmei.entity"/&gt;<br />
    &lt;/typeAliases&gt;

    &lt;!-- &lt;environments default="development"&gt;<br />
        &lt;environment id="development"&gt;<br />
            &lt;transactionManager type="JDBC" /&gt;<br />
            &lt;dataSource type="POOLED"&gt;<br />
                &lt;property name="driver" value="${jdbc.driver}" /&gt;<br />
                &lt;property name="url" value="${jdbc.url}" /&gt;<br />
                &lt;property name="username" value="${jdbc.username}" /&gt;<br />
                &lt;property name="password" value="${jdbc.password}" /&gt;<br />
            &lt;/dataSource&gt;<br />
        &lt;/environment&gt;<br />
    &lt;/environments&gt; --&gt;<br />
    &lt;mappers&gt;<br />
        &lt;!--注册BookMapper映射--&gt;<br />
        &lt;mapper resource="com/lmei/mapper/BookMapper.xml" /&gt;<br />
    &lt;/mappers&gt;<br />
&lt;/configuration&gt;</pre>
</div>
<p>3、编写测试类TestMyBatisSpring</p>
<div>
<pre class="prettyprint linenums">package com.lmei.test;

import static org.junit.Assert.assertNotNull;<br />
import java.util.List;<br />
import org.junit.Test;<br />
import org.springframework.context.ApplicationContext;<br />
import org.springframework.context.support.ClassPathXmlApplicationContext;

import com.lmei.dao.BookDaoI;<br />
import com.lmei.entity.Book;

public class TestMyBatisSpring {<br />
    @Test<br />
    public void test() {<br />
        //初始化容器<br />
        ApplicationContext ctx = new ClassPathXmlApplicationContext("ApplicationContext.xml");

        BookDaoI bookDao = ctx.getBean("bookDao",BookDaoI.class);

        List&lt;Book&gt; books = bookDao.getAllBook();<br />
        for (Book book : books) {<br />
            System.out.println(book.getBookName());<br />
        }<br />
        assertNotNull(books);<br />
    }<br />
}</pre>
</div>
<p>项目右键-&gt;Run As-&gt;JUnit Test，控制台输出</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170706190246534-1486060763.jpg" /></p>
<h3><strong>四、Spring与MyBatis整合升级</strong></h3>
<p>1、修改ApplicationContext.xml，弃用MyBatisCfg.xml</p>
<p>&ldquo;三、Spring与MyBatis初级整合&rdquo;中ApplicationContext.xml需要用到MyBatisCfg.xml</p>
<div>
<pre class="prettyprint linenums">&lt;bean id="sqlSessionFactory" class="org.mybatis.spring.SqlSessionFactoryBean"&gt;<br />
    &lt;property name="dataSource" ref="jdbcDataSource" /&gt;&lt;property name="configLocation" value="classpath:MyBatisCfg.xml"&gt;&lt;/property&gt; &lt;!--指定配置文件--&gt;<br />
&lt;/bean&gt; </pre>
</div>
<p>MyBatisCfg.xml中，需要注册mapper，如果有多个，需要一一注册比较麻烦</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;<br />
&lt;!DOCTYPE configuration<br />
  PUBLIC "-//mybatis.org//DTD Config 3.0//EN"<br />
  "http://mybatis.org/dtd/mybatis-3-config.dtd"&gt;<br />
&lt;configuration&gt;

    &lt;!--com.lmei.entity下的所有类定义别名 --&gt;<br />
    &lt;typeAliases&gt;<br />
        &lt;package name="com.lmei.entity"/&gt;<br />
    &lt;/typeAliases&gt;

    &lt;mappers&gt;<br />
        &lt;!--注册BookMapper映射--&gt;<br />
        &lt;mapper resource="com/lmei/mapper/BookMapper.xml" /&gt;<br />
    &lt;/mappers&gt;<br />
&lt;/configuration&gt;</pre>
</div>
<p>引入自动扫描，将ApplicationContext.xml进行修改，原MyBatisCfg.xml弃用，将其配置转移到ApplicationContext.xml中</p>
<p>下面代码注释部分为原来配置，优化sql会话工厂bean，新增的自动扫描接口</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="UTF-8"?&gt;

&lt;beans xmlns="http://www.springframework.org/schema/beans"<br />
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:p="http://www.springframework.org/schema/p"<br />
    xmlns:aop="http://www.springframework.org/schema/aop" xmlns:context="http://www.springframework.org/schema/context"<br />
    xsi:schemaLocation="http://www.springframework.org/schema/beans<br />
        http://www.springframework.org/schema/beans/spring-beans.xsd<br />
        http://www.springframework.org/schema/context<br />
        http://www.springframework.org/schema/context/spring-context-4.3.xsd<br />
        http://www.springframework.org/schema/aop<br />
        http://www.springframework.org/schema/aop/spring-aop-4.3.xsd"&gt;

    &lt;!-- 引入db.properties属性文件 --&gt;<br />
    &lt;context:property-placeholder location="classpath:db.properties" /&gt;

    &lt;!--定义一个jdbc数据源，创建一个驱动管理数据源的bean --&gt;<br />
    &lt;bean id="jdbcDataSource"<br />
        class="org.springframework.jdbc.datasource.DriverManagerDataSource"&gt;<br />
        &lt;property name="driverClassName" value="${jdbc.driver}" /&gt;<br />
        &lt;property name="url" value="${jdbc.url}" /&gt;<br />
        &lt;property name="username" value="${jdbc.username}" /&gt;<br />
        &lt;property name="password" value="${jdbc.password}" /&gt;<br />
    &lt;/bean&gt;

    &lt;!--创建一个sql会话工厂bean，指定数据源 --&gt;<br />
    &lt;!--<br />
    &lt;bean id="sqlSessionFactory" class="org.mybatis.spring.SqlSessionFactoryBean"&gt;<br />
        &lt;property name="dataSource" ref="jdbcDataSource" /&gt;指定数据源<br />
        &lt;property name="configLocation" value="classpath:MyBatisCfg.xml"&gt;&lt;/property&gt; 指定配置文件<br />
    &lt;/bean&gt; --&gt;

    &lt;!--创建一个bookDao --&gt;<br />
    &lt;!--<br />
    &lt;bean id="bookDao" class="org.mybatis.spring.mapper.MapperFactoryBean"&gt;<br />
        指定映射文件<br />
        &lt;property name="mapperInterface" value="com.lmei.dao.BookDaoI"&gt;&lt;/property&gt;<br />
        指定sql会话工厂<br />
        &lt;property name="sqlSessionFactory" ref="sqlSessionFactory"&gt;&lt;/property&gt;<br />
    &lt;/bean&gt; --&gt;

    &lt;!--创建一个sql会话工厂bean，指定数据源 --&gt;<br />
    &lt;bean id="sqlSessionFactory" class="org.mybatis.spring.SqlSessionFactoryBean"&gt;<br />
        &lt;!-- 指定数据源 --&gt;<br />
        &lt;property name="dataSource" ref="jdbcDataSource" /&gt;<br />
        &lt;!--类型别名包，默认引入com.lmei.entity下的所有类 --&gt;<br />
        &lt;property name="typeAliasesPackage" value="com.lmei.entity"&gt;&lt;/property&gt;<br />
        &lt;!--指定sql映射xml文件的路径 --&gt;<br />
        &lt;property name="mapperLocations"<br />
            value="classpath:com/lmei/mapper/*Mapper.xml"&gt;&lt;/property&gt;<br />
    &lt;/bean&gt;

    &lt;!--自动扫描映射接口--&gt;<br />
    &lt;bean class="org.mybatis.spring.mapper.MapperScannerConfigurer"&gt;<br />
        &lt;!-- 指定sql会话工厂，在上面配置过的 --&gt;<br />
        &lt;property name="sqlSessionFactoryBeanName" value="sqlSessionFactory"&gt;&lt;/property&gt;<br />
        &lt;!-- 指定基础包，即自动扫描com.lmei.dao这个包下的所有接口类 --&gt;<br />
        &lt;property name="basePackage" value="com.lmei.dao"&gt;&lt;/property&gt;<br />
    &lt;/bean&gt;

    &lt;!--下面的配置暂时未使用 --&gt;<br />
    &lt;context:component-scan base-package="com.lmei"&gt;<br />
    &lt;/context:component-scan&gt;<br />
    &lt;aop:aspectj-autoproxy proxy-target-class="true"&gt;&lt;/aop:aspectj-autoproxy&gt;<br />
&lt;/beans&gt;</pre>
</div>
<p>2、修改测试类TestMyBasticSpring.java</p>
<div>
<pre class="prettyprint linenums">package com.lmei.test;

import static org.junit.Assert.assertNotNull;<br />
import java.util.List;<br />
import org.junit.Test;<br />
import org.springframework.context.ApplicationContext;<br />
import org.springframework.context.support.ClassPathXmlApplicationContext;

import com.lmei.dao.BookDaoI;<br />
import com.lmei.entity.Book;

public class TestMyBatisSpring {<br />
    @Test<br />
    public void test() {<br />
        //初始化容器<br />
        ApplicationContext ctx=new ClassPathXmlApplicationContext("ApplicationContext.xml");<br />
        //获得bean<br />
       /* BookDaoI bookDao = ctx.getBean("bookDao",BookDaoI.class);*/<br />
        BookDaoI bookDao = ctx.getBean(BookDaoI.class);<br />
        //访问数据库<br />
        List&lt;Book&gt; books = bookDao.getAllBook();<br />
        for (Book book : books) {<br />
            System.out.println(book.getBookName());<br />
        }<br />
        assertNotNull(books);<br />
    }<br />
}</pre>
</div>
<p>项目右键-&gt;Run As-&gt;Junit Test</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/369554/201707/369554-20170707151106894-1530528060.jpg" /></p>
<p>以上学习参考资料：</p>
<p><a href="http://www.cnblogs.com/best/p/5638827.html" rel="external nofollow noreferrer">http://www.cnblogs.com/best/p/5638827.html</a></p>
<p><a href="http://www.cnblogs.com/xdp-gacl/p/4271627.html" rel="external nofollow noreferrer">http://www.cnblogs.com/xdp-gacl/p/4271627.html</a></p>
<p>问题解决参考：</p>
<p><a href="http://blog.csdn.net/xwin1989/article/details/6754790" rel="external nofollow noreferrer">http://blog.csdn.net/xwin1989/article/details/6754790</a></p>
<p><a href="http://blog.csdn.net/hy245120020/article/details/51821950" rel="external nofollow noreferrer">http://blog.csdn.net/hy245120020/article/details/51821950</a></p>
<p>@_@)... 未完待续...接下来学习将在下一篇介绍</p>
<h1><a href="http://www.cnblogs.com/lmei/p/7141862.html" rel="external nofollow noreferrer">mybatis学习笔记（六） -- maven+spring+mybatis从零开始搭建整合详细过程（下）</a></h1>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jvn495.html">跟Unity3D学代码优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96gd484.html">浅谈JavaScript中forEach与each</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zpl4n9.html">python装饰器--&commat;property</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnonyx9.html">IOS设计模式浅析之工厂方法模式&lpar;Factory Method&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1pyxj9.html">HBase 建表新增数据记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxndwrd8.html">centos7通过yum安装mysql，并授权远程连接</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdyl678.html">iOS多线程总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ykyv0q.html">WPF-控件-ListView</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdnyrl8.html">CSS控制 table 的 cellpadding&comma;cellspacing</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wgowvq.html">Tomcat 搭配 Nginx 还是 Apache 呢&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wnp3wq.html">android Spinner的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k16mr79.html">ListView 选择多项目返回的之前的那项</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd1p5z8.html">跨服务器的sql使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mp1mjq.html">Objective-C中math&period;h数学计算公式介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jzgm38.html">HTTP2和HTTPS来不来了解一下？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jrd3x8.html">Linux内核入门到放弃-无持久存储的文件系统-《深入Linux内核架构》笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p14738.html">Entity Framework入门教程（12&rpar;--- EF进行批量添加&sol;删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eype7z9.html">laravel好文</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mwx5m8.html">ubuntu16&period;04利用deb包安装mysql</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zygn1x9.html">使用img2html把图片转为网页</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4zk6ke9.html">elasticsearch系列（四）部署</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd3yj79.html">Cohort Analysis and LifeCycle Grids mixed segmentation with R（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg132e8.html">python之路 序列化 pickle&comma;json</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j21xo8.html">python-散列表</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zk1k09.html">WEB前端：浏览器（IE&plus;Chrome&plus;Firefox）常见兼容问题处理--02</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojg66pq.html">Java 9 揭秘（4&period; 模块依赖）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo4w3vq.html">一致性Hash算法与代码实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1r6zyq.html">Docker Hub工作流程-Docker for Web Developers&lpar;6&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/950w6wm8.html">Discuz添加自定义模板广告</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1klel49.html">ecshop邮件订阅按&OpenCurlyDoubleQuote;订阅&rdquo;没反应</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
